// SparkFun Serial LCD example 2
// Format and display fake RPM and temperature data

// This sketch is for Arduino versions prior to 1.0
// If you're using Arduino version 1.0 or later, use
// the other example code available on the tutorial page.

// This sketch uses the NewSoftSerial library by Mikal Hart.
// You can download it from http://arduiniana.org/libraries/newsoftserial/
// Place the "NewSoftSerial" folder in your arduino sketch / libraries folder.

// Use the NewSoftSerial library to create a new "soft" serial port
// for the display. This prevents display corruption when uploading code.
#include <NewSoftSerial.h>

// Attach the serial display's RX line to digital pin 2
NewSoftSerial mySerial(3,2); // pin 2 = TX, pin 3 = RX (unused)

void setup()
{ 
  mySerial.begin(9600); // set up serial port for 9600 baud
  delay(500); // wait for display to boot up

  mySerial.print(254, BYTE); // cursor to beginning of first line
  mySerial.print(128, BYTE);

  mySerial.print("RPM:            "); // clear display + legends
  mySerial.print("TEMP:           ");
} 

int temp, rpm;
char tempstring[10], rpmstring[10]; // create string arrays

void loop() 
{ 
  temp = random(1000); // make some fake data
  rpm = random(10000);

  sprintf(tempstring,"%4d",rpm); // create strings from the numbers
  sprintf(rpmstring,"%4d",temp); // right-justify to 4 spaces

  mySerial.print(254, BYTE); // cursor to 7th position on first line
  mySerial.print(134, BYTE);
 
  mySerial.print(rpmstring); // print out the RPM value

  mySerial.print(254, BYTE); // cursor to 7th position on second line
  mySerial.print(198, BYTE);

  mySerial.print(tempstring); // print out the TEMP value
  
  delay(1000); // short delay
}
